<template>
  <b-button
    variant="success"
    v-b-modal.create-build-modal
    v-show="me && me.groups.includes('MOD')"
  >
    <b-icon-file-plus />
    Build

    <b-modal
      id="create-build-modal"
      :title="`Create ${system.name} build`"
      @ok="submit"
      ok-variant="success"
    >
      <p v-show="error" style="color: red">
        Something went wrong, please double-check your input or try it later
        again. Error message: {{ error }}
      </p>

      <b-form>
        <label for="tag">Tag</label>
        <b-form-input
          id="tag"
          v-model="tag"
          :state="tag.length >= 1"
          placeholder="Build tag"
          trim
        />

        <label for="channel">Channel</label>
        <b-form-input
          id="channel"
          v-model="channel"
          placeholder="release channel"
          trim
        />
      </b-form>
    </b-modal>
  </b-button>
</template>

<script>
import gql from "graphql-tag";

export default {
  name: "CreateBuild",
  data() {
    return {
      me: {
        groups: []
      },
      error: "",
      tag: "",
      channel: "default"
    };
  },
  apollo: {
    me: {
      query: gql`
        query {
          me {
            id
            name
            groups
            email
            joined
          }
        }
      `
    }
  },
  props: {
    system: Object
  },
  methods: {
    submit(e) {
      e.preventDefault();
      this.$apollo
        .mutate({
          mutation: gql`
            mutation($systemId: ID!, $build: BuildInput!) {
              createBuild(systemId: $systemId, build: $build) {
                id
              }
            }
          `,
          variables: {
            systemId: this.system.id,
            build: {
              tag: this.tag || undefined,
              channel: this.channel || "default"
            }
          }
        })
        .then(
          data => (window.location.href = `/build/${data.data.createBuild.id}`)
        )
        .catch(error => {
          this.error = error;
        });
    }
  }
};
</script>
